=== debian/changelog ===
texworks (0.6.3-3build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:27:42 +0100

texworks (0.6.3-3build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:40:09 +0000

texworks (0.6.3-3) unstable; urgency=medium

  * Add me to list of Uploaders
  * Use python3 for building (Closes: #938659).

 -- Hilmar Preusse <hille42@web.de>  Fri, 06 Sep 2019 23:50:49 +0200

texworks (0.6.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Norbert Preining <norbert@preining.info>  Wed, 10 Jul 2019 17:39:36 +0900

texworks (0.6.3-1) experimental; urgency=medium

  * New upstream release 0.6.3

 -- Norbert Preining <norbert@preining.info>  Sun, 17 Mar 2019 09:07:48 +0900

texworks (0.6.2.20190306-1) experimental; urgency=medium

  * New upstream version 0.6.2.20190306
  * cleanup patches for new release

 -- Norbert Preining <norbert@preining.info>  Wed, 06 Mar 2019 11:35:34 +0900

texworks (0.6.2-4) unstable; urgency=medium

  * fix Homepage fields (Closes: #908118)
  * update VCS and my email, bump standards version

 -- Norbert Preining <norbert@preining.info>  Sat, 02 Mar 2019 15:01:20 +0900
